package cn.com.qmth.stmms.monitor;

import cn.com.qmth.stmms.admin.thread.ScoreCalculateThread;
import cn.com.qmth.stmms.admin.thread.SubjectScoreCalculateThread;
import cn.com.qmth.stmms.biz.exam.service.*;
import cn.com.qmth.stmms.biz.mark.service.MarkService;
import cn.com.qmth.stmms.biz.utils.FormalTaskUtil;
import cn.com.qmth.stmms.biz.utils.TaskEntry;
import cn.com.qmth.stmms.common.utils.DateUtils;
import net.sf.json.JSONArray;
import net.sf.json.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.core.task.AsyncTaskExecutor;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import java.util.Date;
import java.util.Set;

@Controller("scoreMonitor")
@RequestMapping("/monitor/score")
public class ScoreMonitorController {

    @Autowired
    private ExamSubjectService subjectService;

    @Autowired
    private ExamStudentService studentService;

    @Autowired
    private ExamQuestionService questionService;

    @Autowired
    private MarkService markService;

    @Autowired
    private ExamService examService;

    @Autowired
    private MarkGroupService groupService;

    @Autowired
    private AsyncTaskExecutor taskExecutor;

    @RequestMapping("/calculate")
    @ResponseBody
    public Object list(HttpServletRequest request, @RequestParam Integer examId, @RequestParam String subjectCode) {
        SubjectScoreCalculateThread thread = new SubjectScoreCalculateThread(examId, subjectCode, studentService, questionService,
                markService, examService, subjectService, groupService);
        taskExecutor.submit(thread);
        return true;
    }

}
